<template>
  <div style="min-height:620px">
    <div class="ml-5">
      <v-breadcrumbs :items="breadcrumbsAncestors" :large="false">
        <template v-slot:item="{ item }">
          <template v-if="item.disabled && !isNewViewFromParent">
            <v-menu
              class="mt-2"
              :nudge-width="120"
              rounded="0"
              :close-on-content-click="true"
              offset-y
            >
              <template v-slot:activator="{ on, attrs }">
                <v-btn small v-bind="attrs" v-on="on">
                  <v-icon left>
                    mdi-plus
                  </v-icon>
                  {{ item.data.text }}
                  <v-icon right>
                    mdi-chevron-down
                  </v-icon>
                </v-btn>
              </template>
              <v-list>
                <v-list-item>
                  <v-list-item-content>
                    <v-list-item-title class="font-weight-bold"
                      ><strong>Acciones en la vista</strong></v-list-item-title
                    >
                  </v-list-item-content>
                </v-list-item>
                <v-divider></v-divider>
                <v-list-item-group>
                  <v-list-item>
                    <v-list-item-content>
                      <v-list-item-title>
                        <v-btn @click="isNewViewFromParent = true" text plain>
                          Asociar nueva vista
                        </v-btn>
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                  <v-list-item>
                    <v-list-item-content>
                      <v-list-item-title>
                        <v-btn
                          :disabled="isNewViewFromParent"
                          @click="
                            isDialogDeleteView = true;
                            itemToDelete = item;
                          "
                          text
                          plain
                        >
                          Borrar vista
                        </v-btn>
                      </v-list-item-title>
                    </v-list-item-content>
                  </v-list-item>
                </v-list-item-group>
              </v-list>
            </v-menu>
          </template>
          <template v-else>
            <v-btn
              :class="[
                {
                  desac: item.disabled,
                },
              ]"
              small
              @click="selectNode($event, item)"
            >
              {{ item.data.text }}
            </v-btn>
          </template>
        </template>
        <template v-slot:divider>
          <v-icon large>mdi-chevron-right</v-icon>
        </template>
      </v-breadcrumbs>
    </div>
    <div class=" contSecc">
      <div class="titSec">
        {{ textoGestionVista }}
      </div>
    </div>
    <template v-if="isRootView">
      <nueva-vista-principal :instanceTree="instanceTree" />
    </template>
    <template v-if="isNewViewFromParent">
      <div class="pl-10 pr-10 contSecc" style="position: relative;">
        <v-tooltip bottom>
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              fab
              small
              class="white--text"
              color="primary"
              absolute
              right
              top
              v-bind="attrs"
              v-on="on"
              @click="isNewViewFromParent = false"
            >
              <v-icon>mdi-undo</v-icon>
            </v-btn>
          </template>
          <span>Regresar</span>
        </v-tooltip>
      </div>
      <nueva-vista-hija :instanceTree="instanceTree" :parent="vistaIn" />
    </template>
    <template v-if="isEditView">
      <edicion-vista :instanceTree="instanceTree" :vista="vistaIn" />
    </template>
    <div>
      <v-dialog v-model="isDialogDeleteView" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh...! </strong>
            Borrar vista. Estas totalmente seguro?
            <v-icon right color="orange">mdi-alert</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p v-if="itemToDelete.data">
              Para confirmar esta acción por favor escribe:
              <br />
              <em
                ><code>{{ itemToDelete.data.text }}</code></em
              >
            </p>
            <v-text-field
              v-model="confirmText"
              :autofocus="true"
              label="Confirma con el nombre de la vista"
              flat
              class="mr-2 ml-2"
            />
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="isDialogDeleteView = false"
                >No, cancelar</v-btn
              >
              <v-btn
                :class="[
                  {
                    desac: !(
                      itemToDelete.data && confirmText == itemToDelete.data.text
                    ),
                  },
                ]"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteView(itemToDelete)"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </div>
  </div>
</template>
<script>
import store from "@/store";
import NuevaVistaHija from "@/views/secure/accesos/sistema/mapa-sitio/vistas/components/NuevaVistaHija.vue";
import NuevaVistaPrincipal from "@/views/secure/accesos/sistema/mapa-sitio/vistas/components/NuevaVistaPrincipal.vue";
import EdicionVista from "@/views/secure/accesos/sistema/mapa-sitio/vistas/components/EdicionVista.vue";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-GestionVista",
  props: ["vistaIn", "instanceTree"],
  components: {
    NuevaVistaPrincipal,
    NuevaVistaHija,
    EdicionVista,
  },
  data() {
    return {
      tab: null,
      breadcrumbsAncestors: [],
      isRootView: false,
      isNewViewFromParent: false,
      isEditView: false,
      confirmText: null,
      isDialogDeleteView: false,
      itemToDelete: {},
    };
  },
  watch: {
    isNewViewFromParent(val) {
      this.isEditView = !val;
    },
  },
  computed: {
    parent() {
      if (this.vistaIn) {
        return this.vistaIn;
      } else {
        return null;
      }
    },
    textoGestionVista() {
      if (this.isNewViewFromParent && this.parent) {
        return "Asociar nueva vista para el nodo " + this.parent.data.nombre;
      }
      if (this.isRootView) {
        return "Nueva vista principal";
      }
      if (this.isEditView) {
        return "Edición de la vista";
      }
      return null;
    },
  },
  methods: {
    deleteView(itemToDelete) {
      axios
        .delete("/accesos/sistema/vistas/v1/" + itemToDelete.data.idVista)
        .then((response) => {
          this.deleteViewTree(itemToDelete);
          this.isDialogDeleteView = false;
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteViewTree(itemToDelete) {
      if (itemToDelete.vm.node.children.length > 0) {
        let parent = itemToDelete.vm.node.parent;
        itemToDelete.vm.node.children.forEach((node) => {
          node.parent = null;
          if (parent) {
            parent.append(node);
          } else {
            this.instanceTree.append(node);
          }
        });
      }
      itemToDelete.vm.node.unselect();
      itemToDelete.vm.node.remove();
      if (itemToDelete.parent) {
        itemToDelete.parent.select(new Event("click"));
      } else {
        if (itemToDelete.vm.node.children.length > 0) {
          itemToDelete.vm.node.children[0].select(new Event("click"));
        } else {
          if (this.instanceTree.tree.model instanceof Array) {
            if (this.instanceTree.tree.model.length > 0) {
              this.instanceTree.tree.model[0].select(new Event("click"));
            } else {
              this.$emit("force-rerender");
            }
          }
        }
      }
    },
    selectNode($event, item) {
      item.vm.select($event);
    },
    initValues() {
      let ancestors = this.ancestors(this.vistaIn);
      this.breadcrumbsAncestors = ancestors.map((item, index) => {
        return {
          ...item,
          disabled: index == ancestors.length - 1,
          exact: true,
        };
      });
    },
    ancestors(element) {
      let ancestorsListObject = [];
      ancestorsListObject.push(element);
      const pathToTemp = (elementChidren) => {
        if (elementChidren.parent) {
          let data = elementChidren.parent;
          ancestorsListObject.push(data);
          return pathToTemp(elementChidren.parent);
        } else {
          return ancestorsListObject;
        }
      };
      pathToTemp(element);
      return ancestorsListObject
        .map((item, index) => {
          item.index = index;
          return item;
        })
        .sort((a, b) => b.index - a.index)
        .map((item) => {
          delete item.index;
          return item;
        });
    },
  },
  created() {
    if (this.vistaIn && this.vistaIn.data && this.vistaIn.data.idVista) {
      this.isEditView = true;
      this.initValues();
    } else {
      this.isRootView = true;
    }
  },
};
</script>
